---
title: Create Org Connection
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Org Connections
---

# Create Org Connection{% #create-org-connection %}
Copy pageCopied
{% tab title="v2" %}

| Datadog site      | API endpoint                                              |
| ----------------- | --------------------------------------------------------- |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/org_connections |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/org_connections |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/org_connections      |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/org_connections      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/org_connections  |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/org_connections     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/org_connections |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/org_connections |

### Overview

Create a new org connection between the current org and a target org. This endpoint requires the `org_connections_write` permission.

OAuth apps require the `org_connections_write` authorization [scope](https://docs.datadoghq.com/api/latest/scopes.md#org-connections) to access this endpoint.



### Request

#### Body Data (required)



{% tab title="Model" %}

| Parent field  | Field                              | Type     | Description                                                            |
| ------------- | ---------------------------------- | -------- | ---------------------------------------------------------------------- |
|               | data [*required*]             | object   | Org connection creation data.                                          |
| data          | attributes [*required*]       | object   | Attributes for creating an org connection.                             |
| attributes    | connection_types [*required*] | [string] | List of connection types to establish.                                 |
| data          | relationships [*required*]    | object   | Relationships for org connection creation.                             |
| relationships | sink_org [*required*]         | object   | Org relationship.                                                      |
| sink_org      | data                               | object   | The definition of `OrgConnectionOrgRelationshipData` object.           |
| data          | id                                 | string   | Org UUID.                                                              |
| data          | name                               | string   | Org name.                                                              |
| data          | type                               | enum     | The type of the organization relationship. Allowed enum values: `orgs` |
| data          | type [*required*]             | enum     | Org connection type. Allowed enum values: `org_connection`             |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "type": "org_connection",
    "relationships": {
      "sink_org": {
        "data": {
          "type": "orgs",
          "id": "83999dcd-7f97-11f0-8de1-1ecf66f1aa85"
        }
      }
    },
    "attributes": {
      "connection_types": [
        "logs"
      ]
    }
  }
}
```

{% /tab %}

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
Response containing a single org connection.

| Parent field  | Field                              | Type      | Description                                                            |
| ------------- | ---------------------------------- | --------- | ---------------------------------------------------------------------- |
|               | data [*required*]             | object    | An org connection.                                                     |
| data          | attributes [*required*]       | object    | Org connection attributes.                                             |
| attributes    | connection_types [*required*] | [string]  | List of connection types.                                              |
| attributes    | created_at [*required*]       | date-time | Timestamp when the connection was created.                             |
| data          | id [*required*]               | uuid      | The unique identifier of the org connection.                           |
| data          | relationships [*required*]    | object    | Related organizations and user.                                        |
| relationships | created_by                         | object    | User relationship.                                                     |
| created_by    | data                               | object    | The data for a user relationship.                                      |
| data          | id                                 | string    | User UUID.                                                             |
| data          | name                               | string    | User name.                                                             |
| data          | type                               | enum      | The type of the user relationship. Allowed enum values: `users`        |
| relationships | sink_org                           | object    | Org relationship.                                                      |
| sink_org      | data                               | object    | The definition of `OrgConnectionOrgRelationshipData` object.           |
| data          | id                                 | string    | Org UUID.                                                              |
| data          | name                               | string    | Org name.                                                              |
| data          | type                               | enum      | The type of the organization relationship. Allowed enum values: `orgs` |
| relationships | source_org                         | object    | Org relationship.                                                      |
| source_org    | data                               | object    | The definition of `OrgConnectionOrgRelationshipData` object.           |
| data          | id                                 | string    | Org UUID.                                                              |
| data          | name                               | string    | Org name.                                                              |
| data          | type                               | enum      | The type of the organization relationship. Allowed enum values: `orgs` |
| data          | type [*required*]             | enum      | Org connection type. Allowed enum values: `org_connection`             |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "connection_types": [
        "logs",
        "metrics"
      ],
      "created_at": "2023-01-01T12:00:00Z"
    },
    "id": "f9ec96b0-8c8a-4b0a-9b0a-1b2c3d4e5f6a",
    "relationships": {
      "created_by": {
        "data": {
          "id": "usr123abc456",
          "name": "John Doe",
          "type": "users"
        }
      },
      "sink_org": {
        "data": {
          "id": "f9ec96b0-8c8a-4b0a-9b0a-1b2c3d4e5f6a",
          "name": "Example Org",
          "type": "orgs"
        }
      },
      "source_org": {
        "data": {
          "id": "f9ec96b0-8c8a-4b0a-9b0a-1b2c3d4e5f6a",
          "name": "Example Org",
          "type": "orgs"
        }
      }
    },
    "type": "org_connection"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="401" %}
Unauthorized
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="404" %}
Not Found
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="409" %}
Conflict
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                          \## default
# 
 \# Curl command curl -X POST "https://api.datadoghq.com/api/v2/org_connections" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "connection_types": [
        "logs"
      ]
    },
    "relationships": {
      "sink_org": {
        "data": {
          "id": "f9ec96b0-8c8a-4b0a-9b0a-1b2c3d4e5f6a",
          "name": "Example Org",
          "type": "orgs"
        }
      }
    },
    "type": "org_connection"
  }
}
EOF 
                        
##### 

```go
// Create Org Connection returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.OrgConnectionCreateRequest{
		Data: datadogV2.OrgConnectionCreate{
			Type: datadogV2.ORGCONNECTIONTYPE_ORG_CONNECTION,
			Relationships: datadogV2.OrgConnectionCreateRelationships{
				SinkOrg: datadogV2.OrgConnectionOrgRelationship{
					Data: &datadogV2.OrgConnectionOrgRelationshipData{
						Type: datadogV2.ORGCONNECTIONORGRELATIONSHIPDATATYPE_ORGS.Ptr(),
						Id:   datadog.PtrString("83999dcd-7f97-11f0-8de1-1ecf66f1aa85"),
					},
				},
			},
			Attributes: datadogV2.OrgConnectionCreateAttributes{
				ConnectionTypes: []datadogV2.OrgConnectionTypeEnum{
					datadogV2.ORGCONNECTIONTYPEENUM_LOGS,
				},
			},
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewOrgConnectionsApi(apiClient)
	resp, r, err := api.CreateOrgConnections(ctx, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `OrgConnectionsApi.CreateOrgConnections`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `OrgConnectionsApi.CreateOrgConnections`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Create Org Connection returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.OrgConnectionsApi;
import com.datadog.api.client.v2.model.OrgConnectionCreate;
import com.datadog.api.client.v2.model.OrgConnectionCreateAttributes;
import com.datadog.api.client.v2.model.OrgConnectionCreateRelationships;
import com.datadog.api.client.v2.model.OrgConnectionCreateRequest;
import com.datadog.api.client.v2.model.OrgConnectionOrgRelationship;
import com.datadog.api.client.v2.model.OrgConnectionOrgRelationshipData;
import com.datadog.api.client.v2.model.OrgConnectionOrgRelationshipDataType;
import com.datadog.api.client.v2.model.OrgConnectionResponse;
import com.datadog.api.client.v2.model.OrgConnectionType;
import com.datadog.api.client.v2.model.OrgConnectionTypeEnum;
import java.util.Collections;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    OrgConnectionsApi apiInstance = new OrgConnectionsApi(defaultClient);

    OrgConnectionCreateRequest body =
        new OrgConnectionCreateRequest()
            .data(
                new OrgConnectionCreate()
                    .type(OrgConnectionType.ORG_CONNECTION)
                    .relationships(
                        new OrgConnectionCreateRelationships()
                            .sinkOrg(
                                new OrgConnectionOrgRelationship()
                                    .data(
                                        new OrgConnectionOrgRelationshipData()
                                            .type(OrgConnectionOrgRelationshipDataType.ORGS)
                                            .id("83999dcd-7f97-11f0-8de1-1ecf66f1aa85"))))
                    .attributes(
                        new OrgConnectionCreateAttributes()
                            .connectionTypes(
                                Collections.singletonList(OrgConnectionTypeEnum.LOGS))));

    try {
      OrgConnectionResponse result = apiInstance.createOrgConnections(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling OrgConnectionsApi#createOrgConnections");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```python
"""
Create Org Connection returns "OK" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.org_connections_api import OrgConnectionsApi
from datadog_api_client.v2.model.org_connection_create import OrgConnectionCreate
from datadog_api_client.v2.model.org_connection_create_attributes import OrgConnectionCreateAttributes
from datadog_api_client.v2.model.org_connection_create_relationships import OrgConnectionCreateRelationships
from datadog_api_client.v2.model.org_connection_create_request import OrgConnectionCreateRequest
from datadog_api_client.v2.model.org_connection_org_relationship import OrgConnectionOrgRelationship
from datadog_api_client.v2.model.org_connection_org_relationship_data import OrgConnectionOrgRelationshipData
from datadog_api_client.v2.model.org_connection_org_relationship_data_type import OrgConnectionOrgRelationshipDataType
from datadog_api_client.v2.model.org_connection_type import OrgConnectionType
from datadog_api_client.v2.model.org_connection_type_enum import OrgConnectionTypeEnum

body = OrgConnectionCreateRequest(
    data=OrgConnectionCreate(
        type=OrgConnectionType.ORG_CONNECTION,
        relationships=OrgConnectionCreateRelationships(
            sink_org=OrgConnectionOrgRelationship(
                data=OrgConnectionOrgRelationshipData(
                    type=OrgConnectionOrgRelationshipDataType.ORGS,
                    id="83999dcd-7f97-11f0-8de1-1ecf66f1aa85",
                ),
            ),
        ),
        attributes=OrgConnectionCreateAttributes(
            connection_types=[
                OrgConnectionTypeEnum.LOGS,
            ],
        ),
    ),
)

configuration = Configuration()
with ApiClient(configuration) as api_client:
    api_instance = OrgConnectionsApi(api_client)
    response = api_instance.create_org_connections(body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Create Org Connection returns "OK" response

require "datadog_api_client"
api_instance = DatadogAPIClient::V2::OrgConnectionsAPI.new

body = DatadogAPIClient::V2::OrgConnectionCreateRequest.new({
  data: DatadogAPIClient::V2::OrgConnectionCreate.new({
    type: DatadogAPIClient::V2::OrgConnectionType::ORG_CONNECTION,
    relationships: DatadogAPIClient::V2::OrgConnectionCreateRelationships.new({
      sink_org: DatadogAPIClient::V2::OrgConnectionOrgRelationship.new({
        data: DatadogAPIClient::V2::OrgConnectionOrgRelationshipData.new({
          type: DatadogAPIClient::V2::OrgConnectionOrgRelationshipDataType::ORGS,
          id: "83999dcd-7f97-11f0-8de1-1ecf66f1aa85",
        }),
      }),
    }),
    attributes: DatadogAPIClient::V2::OrgConnectionCreateAttributes.new({
      connection_types: [
        DatadogAPIClient::V2::OrgConnectionTypeEnum::LOGS,
      ],
    }),
  }),
})
p api_instance.create_org_connections(body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```rust
// Create Org Connection returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_org_connections::OrgConnectionsAPI;
use datadog_api_client::datadogV2::model::OrgConnectionCreate;
use datadog_api_client::datadogV2::model::OrgConnectionCreateAttributes;
use datadog_api_client::datadogV2::model::OrgConnectionCreateRelationships;
use datadog_api_client::datadogV2::model::OrgConnectionCreateRequest;
use datadog_api_client::datadogV2::model::OrgConnectionOrgRelationship;
use datadog_api_client::datadogV2::model::OrgConnectionOrgRelationshipData;
use datadog_api_client::datadogV2::model::OrgConnectionOrgRelationshipDataType;
use datadog_api_client::datadogV2::model::OrgConnectionType;
use datadog_api_client::datadogV2::model::OrgConnectionTypeEnum;

#[tokio::main]
async fn main() {
    let body = OrgConnectionCreateRequest::new(OrgConnectionCreate::new(
        OrgConnectionCreateAttributes::new(vec![OrgConnectionTypeEnum::LOGS]),
        OrgConnectionCreateRelationships::new(
            OrgConnectionOrgRelationship::new().data(
                OrgConnectionOrgRelationshipData::new()
                    .id("83999dcd-7f97-11f0-8de1-1ecf66f1aa85".to_string())
                    .type_(OrgConnectionOrgRelationshipDataType::ORGS),
            ),
        ),
        OrgConnectionType::ORG_CONNECTION,
    ));
    let configuration = datadog::Configuration::new();
    let api = OrgConnectionsAPI::with_config(configuration);
    let resp = api.create_org_connections(body).await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Create Org Connection returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
const apiInstance = new v2.OrgConnectionsApi(configuration);

const params: v2.OrgConnectionsApiCreateOrgConnectionsRequest = {
  body: {
    data: {
      type: "org_connection",
      relationships: {
        sinkOrg: {
          data: {
            type: "orgs",
            id: "83999dcd-7f97-11f0-8de1-1ecf66f1aa85",
          },
        },
      },
      attributes: {
        connectionTypes: ["logs"],
      },
    },
  },
};

apiInstance
  .createOrgConnections(params)
  .then((data: v2.OrgConnectionResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
